;#	Search for MovableType with Anti Spam
;#	@see http://www.magicvox.net/archive/2006/06222006.php
;#			Programmed by Piroli YUKARINOMIYA (MagicVox)
;#			Open MagicVox - http://www.magicvox.net/
package MT::App::SearchAntiSpam;
use strict;

;### Banned IP list
my @IPBListPath = ();
push @IPBListPath, '/home/magicvox/www/www/cgi-bin/mt/plugins/goblin/goblin.txt';
push @IPBListPath, '/home/magicvox/www/www/cgi-bin/admin/hoodlum.txt';

;### NG Words list
my @NGWordsListPath = ();
push @NGWordsListPath, '/home/magicvox/www/www/cgi-bin/admin/ngword.txt';



;########################################################################
use MT::App::Search;
@MT::App::SearchAntiSpam::ISA = qw( MT::App::Search );

sub init {
	my $app = shift;
;#
	$app->SUPER::init (@_) or return;

	;# Check with IP banned List
	my $remote_ip = $app->remote_ip;
	return $app->error ($app->translate ('IP Banning'))
		if isInBlackList ($remote_ip);

	;# Check with NG Words List
	my $search_string = $app->{search_string};
	return $app->error ($app->translate ('Search failed: [_1]', $search_string))
		if isInNGWordsList ($search_string);

	$app;
}



;### Check whether specified remote address is in black lists
sub isInBlackList {
	my $remote_ip = shift;
;#
	foreach my $blist (@IPBListPath) {
		if (open (BLACKLIST, "<$blist")) {
			while (<BLACKLIST>) {
				my ($ip) = $_ =~ /^([\d\.]+)/;
				if ($ip ne "" && $remote_ip =~ m/^\Q$ip\E$/i) {
					close (BLACKLIST);
					return 1;
				}
			}
			close (BLACKLIST);
		}
	}
	return 0;
}

;### Check whether specified word is in NG words lists
sub isInNGWordsList {
	$_ = shift;
;#
	s/^\s+//;			## Remove leading whitespace
	s/\s+$//;			## Remove trailing whitespace
	s/\s+AND\s+/ /g;	## Remove AND because it's implied
	s/\s{2,}/ /g;		## Remove contiguous spaces
	my @tokens = split;

	foreach my $token (@tokens) {
		foreach my $blist (@NGWordsListPath) {
			if (open (NGWORDS, "<$blist")) {
				while (<NGWORDS>) {
					my ($word) = $_ =~ /^(\w+)/;
					if ($word ne "" && $token =~ m/^\Q$word\E$/i) {
						close (NGWORDS);
						return 1;
					}
				}
				close (NGWORDS);
			}
		}
	}
	return 0;
}

1;

__END__
;########################################################################
06/06/22	1.00	ŌJ
